---
title: " "
author: " "
institute: " "
topic: " "
theme: "metropolis"
colortheme:
fonttheme:
fontsize: 11pt
linkcolor: black
urlcolor: blue
linkstyle: bold
aspectratio: 169
titlegraphic: 
logo:
date:
section-titles: false
toc: false
---


## Who am I?

Background in **mathematics** and **data sciences**:

```{=latex}
\vspace*{-.25cm}
\begin{description}
\setlength\itemsep{-.5em}
\item[2012--2016] ENS Paris, mathematics.
\item[2014--2015] M2 mathematics, vision, learning at ENS Cachan.
\item[2016--2019] PhD thesis in \textcolor{red!80!black}{\textbf{medical imaging}} with Alain Trouvé at ENS Cachan.
\item[2019--2021] \textcolor{red!80!black}{\textbf{Geometric deep learning}} with Michael Bronstein at Imperial College.
\item[2021+] \textcolor{red!80!black}{\textbf{Medical data analysis}} in the HeKA INRIA team (Paris).
\end{description}
\vspace*{.4cm}
```

Close ties with `\textbf{\textcolor{red!80!black}{healthcare}}`{=latex}:


```{=latex}
\vspace*{-.25cm}
\begin{description}
\setlength\itemsep{-.5em}
\item[2015+] Medical imaging.
\item[2016+] Computational anatomy.
\item[2021+] Public health.
\end{description}
```

## A focus on the geometric side of data sciences


`\vspace*{.5cm}`{=latex}

![](images/similarity_matrix.pdf){ width=100% }

`\vspace*{.25cm}`{=latex}


`\begin{center}`{=latex}
My research is about understanding **similarity structures**.\
What are the implicit **priors** that they reflect?\
How can we manipulate them **efficiently**?
`\end{center}`{=latex}


## A field that is moving fast

::: columns

:::: {.column width=70%}


`\begin{center}`{=latex}
`\vspace*{.5cm}`{=latex}
`\contexte{Target.}`{=latex} Allow scientists to work with \
**tailor-made** models as **efficiently** as possible.

`\end{center}`{=latex}

\
`\defi{Challenge.}`{=latex} The advent of **Graphics Processing Units** (GPU): \
 \

- Incredible **value for money**: \
  $\qquad$ 1 000€ $\simeq$ 1 000 cores $\simeq$ $\text{10}^{\text{12}}$ operations/s.
- **Bottleneck**: constraints on **register** usage.

`\vspace*{.5cm}`{=latex}
`\begin{center}`{=latex}

"User-friendly" Python ecosystem, consolidated around \
a **small number of key operations**.

`\end{center}`{=latex}

::::

:::: {.column width=25%}

`\begin{center}`{=latex}

`\vspace*{1cm}`{=latex}

![](images/ampere.jpg){height=6cm}

`\vspace*{.25cm}`{=latex}

**7,000 cores**\
in a single GPU.

`\end{center}`{=latex}

::::

:::



## My project: a long-term investiment in the foundations of our field

`\begin{center}`{=latex}

`\vspace*{.25cm}`{=latex}
`\solution{Solution.}`{=latex} **Expand the standard toolbox** in data sciences \
to deal with the challenges of the healthcare industry. \
 \
**Ease** the development of **advanced models**, \
without compromising on numerical performance.

`\vspace*{.5cm}`{=latex}
`\end{center}`{=latex}

Today's talk: `\vspace*{-.25cm}`{=latex}

1. Efficient manipulation of **"symbolic" matrices** (distances, kernel, etc.).
2. **Optimal transport**: generalized sorting methods.
3. The long road to **standardization** and **clinical** impact.


# 1. Symbolic matrices

## Computing libraries represent most objects as tensors



::: columns

:::: {.column width=70%}

`\vspace*{.25cm}`{=latex}
`\contexte{Context.}`{=latex}
Constrained **memory accesses** on the GPU:
`\vspace*{.3cm}`{=latex}

- **Long access times** to the registers \
  penalize the use of large **dense** arrays.

- Hard-wired **contiguous** memory accesses \
  penalize the use of **sparse** matrices.


\
`\defi{Challenge.}`{=latex}
In order to reach optimal run times:
`\vspace*{.3cm}`{=latex}

- **Restrict** ourselves to operations that are supported \
  by the constructor: convolutions, FFT, etc.

- Develop new routines from scratch in C++/CUDA \
  (FAISS, KPConv...): **several months of work**.


::::

:::: {.column width=25%}

`\begin{center}`{=latex}


```{=latex}
\begin{tikzpicture}[scale=.9]
	\draw[draw=black, fill=blue!20] (0,0) rectangle ++(3,3);
	\draw[step=.15, color=gray] (0,0) grid ++(3,3);
	\draw[draw=black, thick] (0,0) rectangle ++(3,3);
	\node[inner sep=3pt, anchor = mid, fill=blue!5, rounded corners=2] at (1.5,1.5) {{\normalsize M[\,i\,,\,j\,]}};
\end{tikzpicture}
```

**Dense array**

```{=latex}
\vspace*{.5cm}

\begin{tikzpicture}[scale=.9]
	\draw[draw=black, thick] (0,0) rectangle ++(3,3);
	\node[inner sep=0pt, anchor = mid] at (1.5,1.5) {{\normalsize ($\text{i}_\text{n}$, $\text{j}_\text{n}$, $\text{M}_\text{n}$)}};
	\draw[fill=blue!20] (4*.15,1*.15) rectangle ++(.15,.15);
	\draw[fill=blue!20] (15*.15,1*.15) rectangle ++(.15,.15);
	%
	\draw[fill=blue!20] (2*.15,2*.15) rectangle ++(.15,.15);
	%
	\draw[fill=blue!20] (9*.15,3*.15) rectangle ++(.15,.15);
	\draw[fill=blue!20] (16*.15,3*.15) rectangle ++(.15,.15);
	%
	%\draw[fill=blue!20] (3*.15,4*.15) rectangle ++(.15,.15);
	\draw[fill=blue!20] (6*.15,4*.15) rectangle ++(.15,.15);
	\draw[fill=blue!20] (4*.15,6*.15) rectangle ++(.15,.15);
	%\draw[fill=blue!20] (14*.15,7*.15) rectangle ++(.15,.15);
	%\draw[fill=blue!20] (2*.15,7*.15) rectangle ++(.15,.15);
	%
	\draw[fill=blue!20] (18*.15,8*.15) rectangle ++(.15,.15);
	\draw[fill=blue!20] (1*.15,9*.15) rectangle ++(.15,.15);
	%\draw[fill=blue!20] (16*.15,10*.15) rectangle ++(.15,.15);
	%
	\draw[fill=blue!20] (6*.15,13*.15) rectangle ++(.15,.15);
	\draw[fill=blue!20] (16*.15,13*.15) rectangle ++(.15,.15);
	\draw[fill=blue!20] (4*.15,14*.15) rectangle ++(.15,.15);
	\draw[fill=blue!20] (12*.15,15*.15) rectangle ++(.15,.15);
	\draw[fill=blue!20] (2*.15,16*.15) rectangle ++(.15,.15);
	\draw[fill=blue!20] (10*.15,17*.15) rectangle ++(.15,.15);
\end{tikzpicture}
```

**Sparse matrix**

`\end{center}`{=latex}

::::

:::

  
## The KeOps library: efficient support for symbolic matrices


::: columns

:::: {.column width=70%}

`\solution{Solution.}`{=latex} 
KeOps -- `\textcolor{blue}{\texttt{www.kernel-operations.io}}`{=latex}: `\vspace*{.2cm}`{=latex}

- For PyTorch, NumPy, Matlab and R, on **CPU and GPU**.
- **Automatic differentiation**.
- Just-in-time **compilation** of **optimized** C++ schemes, \
  triggered for every new **reduction**: sum, min, etc.

\
If the formula "F" is simple ($\leqslant$ 100 arithmetic operations): \
$\qquad$ "100k $\times$ 100k" computation  $\rightarrow$  10ms -- 100ms, \
$\qquad$     "1M $\times$ 1M"    computation  $\rightarrow\phantom{\text{0m}}$ 1s -- 10s.

`\vspace*{.5cm}`{=latex}

`\begin{center}`{=latex}

Hardware ceiling of $\text{10}^{\text{12}}$ operations/s. \
**$\times \textbf{10}$ to $\times \textbf{100}$ speed-up** vs standard GPU implementations \
for a wide range of problems.

`\end{center}`{=latex}

::::

:::: {.column width=25%}

`\begin{center}`{=latex}



```{=latex}
\begin{tikzpicture}[scale=.9]
	% Left border:
	\draw[draw=black, fill=red!20] (-.45,0) rectangle ++(.3,3);
	\draw[draw=black, fill=red!80] (-.45,9*.15) rectangle ++(.3,.15);
	\draw[step=.15, color=gray] (-.45,0) grid ++(.3,3);
	\draw[draw=black] (-.45,0) rectangle ++(.3,3);
	%
	% Top border:
	\draw[draw=black, fill=green!20] (0,3.15) rectangle ++(3,.3);
	\draw[draw=black, fill=green!80] (6*.15,3.15) rectangle ++(.15,.3);
	\draw[step=.15, color=gray] (0,3.15) grid ++(3,.3);
	\draw[draw=green!50!black] (0,3.15) rectangle ++(3,.3);
	%
	\draw[draw=black,thick] (0,0) rectangle ++(3,3);
	%
	\draw[->, thick, color=red!80!black] (.5*.15, 9.5*.15) -- (5*.15, 9.5*.15);
	\draw[->, thick, color=green!50!black] (6.5*.15, 19.5*.15) -- (6.5*.15, 11*.15);
	%
	\draw[fill=blue!40] (6*.15,9*.15) rectangle ++(.15,.15);
	\node[inner sep=0pt, anchor = mid, color=blue!50!black] at (1.95,1.4) {\normalsize{F(\,\textcolor{red!80!black}{$\text{x}_\text{i}$}\,,\,\textcolor{green!50!black}{$\text{y}_\text{j}$}\,)}};
\end{tikzpicture}
```

**Symbolic matrix** \
Formula + data
 

`\end{center}`{=latex}
`\vspace*{.5cm}`{=latex}


- Distances `d(\textcolor{red!80!black}{$\text{x}_\text{i}$},\textcolor{green!50!black}{$\text{y}_\text{j}$})`{=latex}.
- Kernel `k(\textcolor{red!80!black}{$\text{x}_\text{i}$},\textcolor{green!50!black}{$\text{y}_\text{j}$})`{=latex}.
- Numerous transforms.


::::

:::


```{=latex}

\end{frame}

\begin{frame}[fragile]{A first example: efficient nearest neighbor search in dimension 50}

Create large point clouds using \textbf{standard PyTorch syntax}:
\vspace*{-.3cm}
\begin{minted}[bgcolor=blue!4,fontsize=\footnotesize,mathescape,tabsize=4,escapeinside=||]{python}
import torch
N, M, D = 10**6, 10**6, 50
x = torch.rand(N, 1, D).cuda()  # (1M,  1, 50) array
y = torch.rand(1, M, D).cuda()  # ( 1, 1M, 50) array
\end{minted}

%\pause
\vspace*{-.6cm}
Turn \textbf{dense} arrays into \textbf{symbolic} matrices:
\vspace*{-.3cm}
\begin{minted}[bgcolor=blue!4,fontsize=\footnotesize,mathescape,tabsize=4,escapeinside=||,highlightlines={1-2}]{python}
from pykeops.torch import LazyTensor
x_i, y_j = LazyTensor(x), LazyTensor(y)
\end{minted}

%\pause
\vspace*{-.6cm}
Create a large \textbf{symbolic matrix} of squared distances:
\vspace*{-.3cm}
\begin{minted}[bgcolor=blue!4,fontsize=\footnotesize,mathescape,tabsize=4,escapeinside=||]{python}
D_ij = ((x_i - y_j) ** 2).sum(dim=2)  # (1M, 1M) symbolic
\end{minted}

%\pause
\vspace*{-.6cm}
Use an \texttt{.argmin()} \textbf{reduction}to perform a nearest neighbor query:
\vspace*{-.3cm}
\begin{minted}[bgcolor=blue!4,fontsize=\footnotesize,mathescape,tabsize=4,escapeinside=||]{python}
indices_i = D_ij.argmin(dim=1)  # -> standard torch tensor
\end{minted}

\end{frame}


\begin{frame}[fragile]{The KeOps library combines performance with flexibility}

\begin{center}

```

Script of the previous slide = efficient nearest neighbor query,\
**on par** with the bruteforce CUDA scheme of the **FAISS** library...\
And can be used with **any metric**!

```{=latex}
\end{center}

\begin{minted}[bgcolor=blue!4,fontsize=\footnotesize,mathescape,tabsize=4]{python}
D_ij = ((x_i - x_j) ** 2).sum(dim=2)     # Euclidean
M_ij =  (x_i - x_j).abs().sum(dim=2)     # Manhattan
C_ij = 1 - (x_i | x_j)                   # Cosine
H_ij = D_ij / (x_i[...,0] * x_j[...,0])  # Hyperbolic
\end{minted}

\vspace*{-.4cm}
```

KeOps supports arbitrary **formulas** and **variables** with:

- **Reductions:** sum, log-sum-exp, K-min, matrix-vector product, etc.
- **Operations:** $+$, $\times$, sqrt, exp, neural networks, etc.
- **Advanced schemes:** batch processing, block sparsity, etc.
- **Automatic differentiation:** seamless integration with PyTorch.

```{=latex}
\end{frame}

\begin{frame}{KeOps lets users work with millions of points at a time}

\begin{center}
	Benchmark of a Gaussian \textbf{convolution}\\
	between \textbf{clouds of N 3D points} on a RTX 2080 Ti GPU. 
	%\vspace*{-.3cm}

	\resizebox{.85\linewidth}{!}{\input{images/benchmarks/benchmark_gaussianconv.tex}}
\end{center}
```

# Applications

## KeOps is a good fit for machine learning research

::: columns

:::: {.column width=50%}

`\begin{center}`{=latex}

![](images/applications/kmeans_2D.png){height=5cm}

`\vspace*{.25cm}`{=latex}
K-Means.
`\end{center}`{=latex}

::::


:::: {.column width=50%}

`\begin{center}`{=latex}

![](images/applications/GMM.png){height=5cm}

`\vspace*{.25cm}`{=latex}
Gaussian Mixture Model.
`\end{center}`{=latex}

::::

:::

`\begin{center}\vspace*{.3cm}`{=latex}
Use **any** kernel, metric or formula **you** like!
`\end{center}`{=latex}


## KeOps is a good fit for machine learning research

::: columns

:::: {.column width=50%}

`\begin{center}`{=latex}

![](images/applications/spectral.png){height=5cm}

`\vspace*{.25cm}`{=latex}
Spectral analysis.
`\end{center}`{=latex}

::::


:::: {.column width=50%}

`\begin{center}`{=latex}

![](images/applications/WordNet.png){height=5cm}

`\vspace*{.25cm}`{=latex}
UMAP in hyperbolic space.
`\end{center}`{=latex}

::::

:::

`\begin{center}\vspace*{.21cm}`{=latex}
Use **any** kernel, metric or formula **you** like!
`\end{center}`{=latex}


## Applications to Kriging, spline, Gaussian process, kernel regression

**A standard tool for regression** `\cite{leclercq2018bayesian}`{=latex}:

`\begin{center}`{=latex}

![](images/applications/GP_regression.png){height=3.5cm}

`\end{center}`{=latex}

Under the hood, solve a **kernel linear system**:

`\vspace*{-.5cm}`{=latex}

$$ (\lambda \,\text{Id} + K_{xx}) \,a ~=~b 
\qquad\text{i.e.}\qquad
a ~\gets~(\lambda \,\text{Id} + K_{xx})^{-1} b $$

where $~~\lambda \geqslant 0~~$ et $~~(K_{xx})_{i,j} = k(x_i,x_j)~~$ is a positive definite matrix.


## Applications to Kriging, spline, Gaussian process, kernel regression

**KeOps symbolic tensors $~~(K_{xx})_{i,j} = k(x_i,x_j)~$:**

- Can be fed to **standard solvers**: SciPy, GPyTorch, etc. \

- GPytorch on the 3DRoad dataset (N = 278k, D = 3):
  `\centerline{\defi{\textbf{7h} with 8 GPUs} $~~\rightarrow~~$ \solution{\textbf{15mn} with 1 GPU.}}`{=latex} \
   \

- Provide a **fast backend for research codes**:\
  see e.g. *Kernel methods through the roof: handling **billions of points** efficiently*, \
  by G. Meanti, L. Carratino, L. Rosasco, A. Rudi (2020).

## Geometric deep learning

::: columns

:::: {.column width=75%}

`\vspace*{.1cm}`{=latex}
`\contexte{Context.}`{=latex}
Trainable models on **non-Euclidean domains** \
(point clouds, surfaces, graphs, etc.),
beyond 2D/3D images.

\
`\defi{Challenge.}`{=latex}
In spite of growing interest in the industry, \
these models still **lack support** on the numerical side. \
C++/CUDA is (often) required to reach top performance.


\
`\solution{Solution.}`{=latex}
Using KeOps, with a few lines of Python:


- **Local** interactions: K-nearest neighbors.
- **Global** interactions: generalized convolutions.

`\vspace*{.35cm}\begin{center}`{=latex}

Modelling **freedom** \
$\Longrightarrow$  **Domain-specific** priors.

`\end{center}`{=latex}

::::

:::: {.column width=22%}

`\begin{center}`{=latex}

![](images/applications/coordinates_gris.png){height=6cm}

Quasi-geodesic convolution on a protein surface.

`\end{center}`{=latex}


::::

:::



# 2. Fast optimal transport solvers

## Optimal transport (OT) generalizes sorting to spaces of dimension D $>$ 1

::: columns

:::: {.column width=70%}

`~\\~\\\contexte{Context.}`{=latex}
If $\a{\text{A} = (\text{x}_\text{1}, \dots, \text{x}_\text{N})}$  and  $\b{\text{B} = (\text{y}_\text{1}, \dots, \text{y}_\text{N})}$ \
are two clouds of N points in $\mathbb{R}^\text{D}$,
we define:

```{=latex}
\vspace*{-.3cm}
\begin{equation*}
\OT(\a{\text{A}},\b{\text{B}}) ~=~ \min_{\sigma \in \mathcal{S}_\text{N}}~ \frac{\text{1}}{\text{2N}} \sum_{\text{i\,=1}}^\text{N} \v{\|~\a{\text{x}_i} - \b{\text{y}_{\sigma(i)}}\|^2}
\end{equation*}
\vspace*{.2cm}
```

Generalizes **sorting** to metric spaces.\
We turn a **distance matrix** into a **permutation**.\
\
We extend this definition to **weighted** samples, \
**continuous** distributions with **outliers**, etc.

::::

:::: {.column width=25%}

```{=latex}
\begin{center}
	\begin{tikzpicture}[scale=.5,x=.7cm,y=-.7cm]
		%\node[anchor = east] at (0,4) {source};
		\draw[->,>=latex,thick,color=black]  (0,0)--(0,16.5);
		\node[circle,fill=red!80!black,inner sep=0pt,minimum size=7pt,label=left:{$\a{\text{x}_\text{1}}$}] (x1) at (0,1) {};
		\node[circle,fill=red!80!black,inner sep=0pt,minimum size=7pt,label=left:{$\a{\text{x}_\text{2}}$}] (x2) at (0,2) {};
		\node[circle,fill=red!80!black,inner sep=0pt,minimum size=7pt,label=left:{$\a{\text{x}_\text{3}}$}] (x3) at (0,3.5) {};
		\node[circle,fill=red!80!black,inner sep=0pt,minimum size=7pt,label=left:{$\a{\text{x}_\text{4}}$}] (x4) at (0,5) {};
		\node[circle,fill=red!80!black,inner sep=0pt,minimum size=7pt,label=left:{$\a{\text{x}_\text{5}}$}] (x5) at (0,7.5) {};


		%\node[anchor = east] at (0,0) {cible};
		\draw[->,>=latex,thick,color=black]  (4,0)--(4,16.5);
		\node[circle,fill=blue,inner sep=0pt,minimum size=7pt,label=right:{$\b{\text{y}_\text{3}}$}] (y1) at (4,5.5) {};
		\node[circle,fill=blue,inner sep=0pt,minimum size=7pt,label=right:{$\b{\text{y}_\text{5}}$}] (y2) at (4,7) {};
		\node[circle,fill=blue,inner sep=0pt,minimum size=7pt,label=right:{$\b{\text{y}_\text{2}}$}] (y3) at (4,8.5) {};
		\node[circle,fill=blue,inner sep=0pt,minimum size=7pt,label=right:{$\b{\text{y}_\text{4}}$}] (y4) at (4,12.5) {};
		\node[circle,fill=blue,inner sep=0pt,minimum size=7pt,label=right:{$\b{\text{y}_\text{1}}$}] (y5) at (4,15) {};

		\node[anchor = north, align=center, color=otplan!70!black] at (2,17) {{assignment}\\ ${\sigma:\zp[i]{1,5}\rightarrow \zp[i]{1,5}}$};

		\draw[color=otplan,very thick] (x1) -- (y1) (x2) -- (y2) (x3) -- (y3) (x4) -- (y4) (x5) -- (y5);

		%\onslide<2,3,4,6->{\draw[color=green!80!black,thick] (x3) -- (y3) (x4) -- (y4);}
		%\onslide<5>{\draw[color=green!80!black] (x4) -- (y3);
		%\draw[color=green!80!black, very thick] (x3) -- (y4);}

	\end{tikzpicture}
	\end{center}
```

::::

:::

## Optimal transport has two main uses in data sciences

::: columns

:::: {.column width=70%}

\
\
The **optimal matching** $~~\a{\text{x}_\text{i}} \mapsto \b{\text{y}_{\sigma(\text{i})}}~~$ is:

- A **nearest neighbor** projection subject to \
  a **bijectivity** constraint.
- A fundamental operation in 3D shape analysis.
- A staple of operations research.

\
\
The **total cost** $\OT(\a{\text{A}},\b{\text{B}})$ induces:

- A useful **distance** between probability distributions.
- Particle-based **interpolation**
  with \
  $~~\arg\min_{\a{\text{A}}} \lambda_\text{1}\OT(\a{\text{A}}, \b{\text{B}_\text{1}}) + \dots + \lambda_\text{K}\OT(\a{\text{A}}, \b{\text{B}_\text{K}})$.

::::

:::: {.column width=25%}

`\begin{center}`{=latex}

![](images/wasserstein/Gaussian_wasserstein_small.png){height=4cm}

**OT geodesic**

```{=latex}
\vspace*{.5cm}
```

![](images/wasserstein/wasserstein_barycenters.png){height=4cm}

**OT barycenters**

`\end{center}`{=latex}

::::

:::


## But how should we solve the OT problem?

Key dates for discrete optimal transport with N points:

- `\cite{kantorovich1942translocation}`{=latex}: `\defi{Dual}`{=latex} problem of Kantorovitch.
- `\cite{kuhn1955hungarian}`{=latex}: `\defi{Hungarian}`{=latex} methods in $O(\text{N}^3)$.
- `\cite{bertsekas79auction}`{=latex}: **Auction** algorithm in $O(\text{N}^2)$.
- `\cite{kosowsky1994invisible}`{=latex}: **SoftAssign** = Sinkhorn + simulated annealing, in $O(\text{N}^2)$.
- `\cite{gold1998new,TPSRPM}`{=latex}: **Robust Point Matching** = Sinkhorn as a loss.
- `\cite{CuturiSinkhorn}`{=latex}: Start of the `\contexte{GPU era.}`{=latex}
- `\cite{merigot2011multiscale,levy2015numerical,schmitzer2019stabilized}`{=latex}: **multi-scale** solvers in $O(\text{N}\log \text{N})$. \
  $~$
- `\solution{Solution,}`{=latex}today: **Multiscale Sinkhorn algorithm, on the GPU**.


`\begin{center}`{=latex}
$\Longrightarrow$ Generalized `\solution{QuickSort}`{=latex}algorithm.
`\end{center}`{=latex}


## Scaling up optimal transport to anatomical data

```{=latex}

\begin{center} 
	Progresses of the last decade add up to a 
	$\times \textbf{100}$ - $\times \textbf{1000}$ acceleration:
	
	Sinkhorn GPU
	$\xrightarrow{\times \text{10}}$
	+ KeOps
	$\xrightarrow{\times \text{10}}$
	+ Annealing
	$\xrightarrow{\times \text{10}}$
	+ Multi-scale
	
	
	With a precision of 1\%, on a modern gaming GPU:\\~
	\end{center}

	\vspace*{-.25cm}
	\begin{tabular}{cccc}
	\begin{minipage}{.2\linewidth}
	\begin{center}
	~\\
	\texttt{pip install geomloss}\\
	+\\
	modern GPU\\ (1 000 €)
	\end{center}
	\end{minipage}
	&
	\begin{minipage}{.1\linewidth}
	~\\
	$\Longrightarrow$
	\end{minipage}
	&
	\begin{minipage}{.3\linewidth}
	\includegraphics[height=3.5cm]{images/dragon_ball/lowres.png}
	\end{minipage}
	&
	\begin{minipage}{.3\linewidth}
	\includegraphics[height=3.5cm]{images/dragon_ball/highres.png}
	\end{minipage}
	\\
	&&
	10k points in 30-50ms
	&
	\textbf{100k points in 100-200ms}
	\end{tabular}
```







# Conclusion


## Key points

- `\solution{Symbolic}`{=latex}matrices are to **geometric** ML what \
       **sparse** matrices are to **graph** processing: \
  $\longrightarrow~~$ KeOps: **x30 speed-up** vs. PyTorch, TF et JAX. \
  $\longrightarrow~~$ Useful in a wide range of settings. \
  \
- Optimal Transport = `\solution{generalized sorting}`{=latex}: \
  $\longrightarrow~~$ Simple registration for shapes that are close to each other. \
  $\longrightarrow~~$ Super-fast $O(\text{N}\log \text{N})$ solvers.\
  \
- These tools open **new paths** for geometers and statisticians: \
  $\longrightarrow~~$ GPUs are more **versatile** than you think. \
  $\longrightarrow~~$ Ongoing work to provide **fast GPU backends** to researchers, \
  $\phantom{\longrightarrow}~~~$ going beyond what Google and Facebook are ready to pay for. \




## Summary: a long-term investment that is starting to bear fruits

Two major evolutions:

- "Big" geometric problem:     N $>$ **10k**    $\longrightarrow$    N $>$ **1M**.
- Optimal transport:        linear **problem**     $\,\,+\,\,$    generalized **quicksort**.



`\begin{center}`{=latex}
`\vspace*{.75cm}`{=latex}

![](images/projet/bilan.pdf){width=90%}

`\end{center}`{=latex}



## Genuine team work

```{=latex}
\vspace*{.5cm}

\centerline{
\begin{tabular}{cccc}
\includegraphics[height=2cm]{images/sourires/medaillons/Alain_2.png}
&
\includegraphics[height=2cm]{images/sourires/medaillons/Thibault_2.png}
&
\includegraphics[height=2cm]{images/sourires/medaillons/FX_2.png}
&
\includegraphics[height=2cm]{images/sourires/medaillons/Gabriel_2.png}
\\
Alain Trouvé
&
\textcolor{red!65!black}{Thibault Séjourné}
&
\textcolor{red!65!black}{F.-X. Vialard}
&
\textcolor{red!65!black}{Gabriel Peyré}
\\[.5cm]
\includegraphics[height=2cm]{images/sourires/medaillons/Benjamin_2.png}
&
\includegraphics[height=2cm]{images/sourires/medaillons/Joan_2.png}
&
\includegraphics[height=2cm]{images/sourires/medaillons/Freyr.png}
&
\includegraphics[height=2cm]{images/sourires/medaillons/Zhengyang.png}\\
\textcolor{blue!100!black}{Benjamin Charlier}
&
\textcolor{blue!100!black}{Joan Glaunès}
&
\textcolor{green!60!black}{Freyr Sverrisson}
&
\textcolor{green!60!black}{Shen Zhengyang}\\[.5cm]
\multicolumn{4}{c}{+ Marc Niethammer, Bruno Correia, Michael Bronstein\dots{}}
\end{tabular}
}

```




## Going forward: the long road to genuine clinical impact


```{=latex}
\begin{center}
```
These tools are diffusing well in our
research communities (400k+ downloads). \
The target is now to **go beyond "expert users"**.\

```{=latex}
\end{center}
```

First step in March 2022: removed all problematic **dependencies** from KeOps 2.0.

We are now working on:

- High performance on **CPU**.
- A 100% transparent and NumPy-compatible **API** for KeOps+GeomLoss.
- Standard **benchmarks** for kernel methods and optimal transport. \
- Applications to **drug consumption** data from the SNDS\
  with Anne-Sophie Jannot, Alexis Van Straaten and Pierre Sabatier.

I hope that we'll have nice results to show you soon :-)


## Documentation and tutorials are available online

```{=latex}
\begin{center}
$\Longrightarrow$\qquad \url{www.kernel-operations.io}\qquad $\Longleftarrow$
\vspace*{.15cm}

\includegraphics[width=.45\linewidth,frame]{images/geometric_data_analysis.png}

%\vspace*{.15cm}

\url{www.jeanfeydy.com/geometric_data_analysis.pdf} \\
\url{www.jeanfeydy.com/Teaching}

\end{center}

```

# References
